<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:json="urn:JSON_SAX_NS">
<xsl:output method="xml"/>
<xsl:template match="/">
  <xsl:apply-templates/>
</xsl:template>
<xsl:template match="json:objectEntry">
  <xsl:variable name="elName" select="json:key/text()"/>
  <xsl:variable name="elType">
    <xsl:choose>
      <xsl:when test="json:number"><xsl:text>number</xsl:text></xsl:when>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="json:nil"><xsl:text>nil</xsl:text></xsl:when>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="json:string"><xsl:text>string</xsl:text></xsl:when>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="json:bool"><xsl:text>bool</xsl:text></xsl:when>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="json:array"><xsl:text>array</xsl:text></xsl:when>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="json:number"><xsl:text>number</xsl:text></xsl:when>
    </xsl:choose>
  </xsl:variable>
  <xsl:element name="{$elName}" namespace="">
    <xsl:apply-templates select="*[2]"/>
  </xsl:element>
</xsl:template>
<xsl:template match="json:number|json:string|json:bool">
  <xsl:value-of select="text()"/>
</xsl:template>
<xsl:template match="json:array">
  <xsl:variable name="k" select="preceding-sibling::*[1]"/>
  <xsl:variable name="wrapperName">
    <xsl:choose>
      <xsl:when test="$k='tracks'">track</xsl:when>
      <xsl:when test="$k='albums'">album</xsl:when>
      <xsl:when test="$k='artists'">artist</xsl:when>
      <xsl:when test="$k='genres'">genre</xsl:when>
    </xsl:choose>
  </xsl:variable>
  <xsl:for-each select="*">
    <xsl:element name="{$wrapperName}" namespace="">
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:for-each>
  <xsl:value-of select="text()"/>
</xsl:template>
</xsl:stylesheet>